import "Turbine.Gameplay";
import "Turbine.UI";
import "PengorosPlugins.BuffBars";
import "PengorosPlugins.UI";

OverrideWindow = class(PengorosPlugins.BuffBars.ListWindow);

function OverrideWindow:Constructor()
    PengorosPlugins.BuffBars.ListWindow.Constructor(self);

    self:SetText(L["Always Shown Effects"]);
    self.Closed = function(sender, args)
        -- save the position
        Settings.instance.overrideX, Settings.instance.overrideY = self:GetPosition();
        Settings.Save();
    end
    
    -- restore the position if there is one
    if (Settings.instance.overrideX ~= nil) then
        self:SetPosition(PengorosPlugins.Utils.ValidatePosition(Settings.instance.overrideX, Settings.instance.overrideY, self:GetWidth(), self:GetHeight()));
    end

    self.GetList = function(sender, settings)
        return settings.override;
    end
    
    self.ResetList = function(sender, settings)
        settings:ResetOverride();
    end
    
    self.AddItemToList = function(sender, settings, item)
        settings:AddOverrideEffect(item);
    end
end
